library ieee;
use ieee.std_logic_1164.all;

entity fsi_prbs_gen is
  generic (
    init : std_logic_vector (7 downto 0));
  port (
    clk_i   : in  std_logic;
    rst_n_i :     std_logic;
    out_o   : out std_logic_vector(7 downto 0));
end fsi_prbs_gen;

architecture arch of fsi_prbs_gen is
  signal taps : std_logic_vector(1 to 31);
begin
  process (clk_i)
    variable t : std_logic_vector(1 to 31);
  begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        taps <= (others => '0');
        taps (1 to 8) <= init;
      else
        t := taps;
        for j in 0 to 7 loop
          --  x**31 + x**28 + 1
          t := (t(31) xor t(28)) & t(1 to 30);
        end loop;
        taps <= t;
      end if;
    end if;
  end process;

  out_o <= taps(24 to 31);
end arch;
