library ieee;
use ieee.std_logic_1164.all;

entity sys_prbs_chk is
  port (
    clk_i   : in  std_logic;
    rst_n_i :     std_logic;
    dat_i   :     std_logic_vector(7 downto 0);
    err_o   : out std_logic_vector(7 downto 0));
end sys_prbs_chk;

architecture arch of sys_prbs_chk is
  signal taps : std_logic_vector(1 to 31);
begin
  process (clk_i)
    variable t : std_logic_vector(1 to 31);
  begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        err_o <= (others => '0');
        taps <= (others => '0');
      else
        t := taps;
        for j in 0 to 7 loop
          --  x**31 + x**28 + 1
          err_o(j) <= dat_i(j) xor (t(31) xor t(28));
          t := dat_i(j) & t(1 to 30);
        end loop;
        taps <= t;
      end if;
    end if;
  end process;
end arch;
