-- Do not edit.  Generated on Tue Nov 23 09:55:22 2021 by tgingold
-- With Cheby 1.5.dev0 and these options:
--  --gen-hdl=sys_top_sub_regs.vhd -i sys_top_sub_regs.cheby


library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity sys_top_sub_reg is
  port (
    aclk                 : in    std_logic;
    areset_n             : in    std_logic;
    awvalid              : in    std_logic;
    awready              : out   std_logic;
    awaddr               : in    std_logic_vector(7 downto 2);
    awprot               : in    std_logic_vector(2 downto 0);
    wvalid               : in    std_logic;
    wready               : out   std_logic;
    wdata                : in    std_logic_vector(31 downto 0);
    wstrb                : in    std_logic_vector(3 downto 0);
    bvalid               : out   std_logic;
    bready               : in    std_logic;
    bresp                : out   std_logic_vector(1 downto 0);
    arvalid              : in    std_logic;
    arready              : out   std_logic;
    araddr               : in    std_logic_vector(7 downto 2);
    arprot               : in    std_logic_vector(2 downto 0);
    rvalid               : out   std_logic;
    rready               : in    std_logic;
    rdata                : out   std_logic_vector(31 downto 0);
    rresp                : out   std_logic_vector(1 downto 0);

    -- REG status
    -- Set at end of DMA transfer, write 1 to clear
    status_dma_done_i    : in    std_logic;
    -- When set, commands or values cannot be transmitted
    status_sampling_i    : in    std_logic;
    status_sampling_o    : out   std_logic;
    -- All peripheral boards are ready
    status_ready_i       : in    std_logic;
    status_ready_o       : out   std_logic;
    -- Data transfer (DMA) in progress
    status_transfer_i    : in    std_logic;
    status_transfer_o    : out   std_logic;

    -- REG control
    -- Sampling software trigger
    control_sw_trig_o    : out   std_logic;
    -- Start PRBS test between periph and sys boards
    control_prbs_o       : out   std_logic;

    -- REG config
    -- Force disable of peripheral boards
    config_periph_off_o  : out   std_logic_vector(7 downto 0);
    -- Clock select
    config_clk_sel_o     : out   std_logic_vector(1 downto 0);
    -- Reset
    config_rst_n_o       : out   std_logic;
    -- Force resync of peripheral boards
    config_resync_o      : out   std_logic;
    -- Select inputs: 0: boards, 1: pattern generator
    config_patterns_o    : out   std_logic;
    -- Enable trigger
    config_trig_en_o     : out   std_logic;

    -- Number of samples for a data transfer
    length_o             : out   std_logic_vector(31 downto 0);

    -- REG address
    configs_0_address_o  : out   std_logic_vector(31 downto 0);

    -- REG cur_address
    configs_0_cur_address_i : in    std_logic_vector(31 downto 0);

    -- REG status
    configs_0_status_axi_i : in    std_logic_vector(3 downto 0);
    configs_0_status_fifo_errs_i : in    std_logic_vector(7 downto 0);
    configs_0_status_fifo_max_i : in    std_logic_vector(7 downto 0);

    -- REG address
    configs_1_address_o  : out   std_logic_vector(31 downto 0);

    -- REG cur_address
    configs_1_cur_address_i : in    std_logic_vector(31 downto 0);

    -- REG status
    configs_1_status_axi_i : in    std_logic_vector(3 downto 0);
    configs_1_status_fifo_errs_i : in    std_logic_vector(7 downto 0);
    configs_1_status_fifo_max_i : in    std_logic_vector(7 downto 0);

    -- REG periph_stat1
    -- SPI busy
    periph_stat1_spi_busy_i : in    std_logic_vector(7 downto 0);
    -- Trigger inputs
    periph_stat1_triggers_i : in    std_logic_vector(7 downto 0);
    -- Servmod inputs (1: not present, 0: present)
    periph_stat1_inp_i   : in    std_logic_vector(7 downto 0);

    -- REG periph_stat2
    -- Ready status
    periph_stat2_fsi_ready_i : in    std_logic_vector(7 downto 0);
    -- sys->periph synchronized
    periph_stat2_sys_locked_i : in    std_logic_vector(7 downto 0);
    -- periph adc synchronized
    periph_stat2_adc_locked_i : in    std_logic_vector(7 downto 0);
    -- periph->sys rx synchronized
    periph_stat2_rx_locked_i : in    std_logic_vector(7 downto 0);

    -- REG cmd_boards
    -- Boards selected for value or commands
    cmd_boards_sel_o     : out   std_logic_vector(7 downto 0);

    -- Value to be sent to the boards
    cmd_value_o          : out   std_logic_vector(31 downto 0);

    -- Control for commands and values
    -- Send the cmd_value to the boards
    cmd_ctrl_send_o      : out   std_logic;
    -- Execute a command (in the cmd_value register)
    cmd_ctrl_exec_o      : out   std_logic;

    -- Status for commands and values
    -- set to 1 (per board) when the transfer is done
    cmd_status_done_i    : in    std_logic_vector(7 downto 0);
    cmd_status_done_o    : out   std_logic_vector(7 downto 0);
    -- set to 1 in case of transfer error
    cmd_status_err_i     : in    std_logic;
    cmd_status_err_o     : out   std_logic;

    -- REG value
    cmd_reply_0_value_i  : in    std_logic_vector(31 downto 0);

    -- REG value
    cmd_reply_1_value_i  : in    std_logic_vector(31 downto 0);

    -- REG value
    cmd_reply_2_value_i  : in    std_logic_vector(31 downto 0);

    -- REG value
    cmd_reply_3_value_i  : in    std_logic_vector(31 downto 0);

    -- REG value
    cmd_reply_4_value_i  : in    std_logic_vector(31 downto 0);

    -- REG value
    cmd_reply_5_value_i  : in    std_logic_vector(31 downto 0);

    -- REG value
    cmd_reply_6_value_i  : in    std_logic_vector(31 downto 0);

    -- REG value
    cmd_reply_7_value_i  : in    std_logic_vector(31 downto 0);

    -- Statistic selection
    -- channel selection
    stat_sel_ch_o        : out   std_logic_vector(3 downto 0);
    -- board selection
    stat_sel_board_o     : out   std_logic_vector(2 downto 0);
    -- delay cell selection (0: idelay, 1: odelay)
    stat_sel_delay_o     : out   std_logic;
    -- delay cell selection (0: data, 1: samp)
    stat_sel_branch_o    : out   std_logic;
    -- Clear statistics and clock
    stat_sel_clear_o     : out   std_logic;

    -- Number of ticks since last stat reset
    stat_clock_i         : in    std_logic_vector(63 downto 0);

    -- Per lane bit lock failure counter
    stat_bit_lock_i      : in    std_logic_vector(31 downto 0);

    -- Per lane byte lock failure counter
    stat_byte_lock_i     : in    std_logic_vector(31 downto 0);

    -- Per lane PRBS errors
    stat_prbs_i          : in    std_logic_vector(31 downto 0);

    -- delay control
    -- voltage temperature calibration
    delay_ctrl_vtc_en_o  : out   std_logic;
    -- freeze delays
    delay_ctrl_freeze_o  : out   std_logic;
    -- increase odelay
    delay_ctrl_inc_o     : out   std_logic;
    -- decrease odelay
    delay_ctrl_dec_o     : out   std_logic;

    -- Per delay cell current value
    delay_cntvalue_i     : in    std_logic_vector(31 downto 0)
  );
end sys_top_sub_reg;

architecture syn of sys_top_sub_reg is
  signal wr_req                         : std_logic;
  signal wr_ack                         : std_logic;
  signal wr_addr                        : std_logic_vector(7 downto 2);
  signal wr_data                        : std_logic_vector(31 downto 0);
  signal axi_awset                      : std_logic;
  signal axi_wset                       : std_logic;
  signal axi_wdone                      : std_logic;
  signal rd_req                         : std_logic;
  signal rd_ack                         : std_logic;
  signal rd_addr                        : std_logic_vector(7 downto 2);
  signal rd_data                        : std_logic_vector(31 downto 0);
  signal axi_arset                      : std_logic;
  signal axi_rdone                      : std_logic;
  signal status_dma_done_reg            : std_logic;
  signal status_wreq                    : std_logic;
  signal status_wack                    : std_logic;
  signal control_sw_trig_reg            : std_logic;
  signal control_prbs_reg               : std_logic;
  signal control_wreq                   : std_logic;
  signal control_wack                   : std_logic;
  signal config_periph_off_reg          : std_logic_vector(7 downto 0);
  signal config_clk_sel_reg             : std_logic_vector(1 downto 0);
  signal config_rst_n_reg               : std_logic;
  signal config_resync_reg              : std_logic;
  signal config_patterns_reg            : std_logic;
  signal config_trig_en_reg             : std_logic;
  signal config_wreq                    : std_logic;
  signal config_wack                    : std_logic;
  signal length_reg                     : std_logic_vector(31 downto 0);
  signal length_wreq                    : std_logic;
  signal length_wack                    : std_logic;
  signal configs_0_address_reg          : std_logic_vector(31 downto 0);
  signal configs_0_address_wreq         : std_logic;
  signal configs_0_address_wack         : std_logic;
  signal configs_1_address_reg          : std_logic_vector(31 downto 0);
  signal configs_1_address_wreq         : std_logic;
  signal configs_1_address_wack         : std_logic;
  signal cmd_boards_sel_reg             : std_logic_vector(7 downto 0);
  signal cmd_boards_wreq                : std_logic;
  signal cmd_boards_wack                : std_logic;
  signal cmd_value_reg                  : std_logic_vector(31 downto 0);
  signal cmd_value_wreq                 : std_logic;
  signal cmd_value_wack                 : std_logic;
  signal cmd_ctrl_send_reg              : std_logic;
  signal cmd_ctrl_exec_reg              : std_logic;
  signal cmd_ctrl_wreq                  : std_logic;
  signal cmd_ctrl_wack                  : std_logic;
  signal stat_sel_ch_reg                : std_logic_vector(3 downto 0);
  signal stat_sel_board_reg             : std_logic_vector(2 downto 0);
  signal stat_sel_delay_reg             : std_logic;
  signal stat_sel_branch_reg            : std_logic;
  signal stat_sel_clear_reg             : std_logic;
  signal stat_sel_wreq                  : std_logic;
  signal stat_sel_wack                  : std_logic;
  signal delay_ctrl_vtc_en_reg          : std_logic;
  signal delay_ctrl_freeze_reg          : std_logic;
  signal delay_ctrl_inc_reg             : std_logic;
  signal delay_ctrl_dec_reg             : std_logic;
  signal delay_ctrl_wreq                : std_logic;
  signal delay_ctrl_wack                : std_logic;
  signal rd_ack_d0                      : std_logic;
  signal rd_dat_d0                      : std_logic_vector(31 downto 0);
  signal wr_req_d0                      : std_logic;
  signal wr_adr_d0                      : std_logic_vector(7 downto 2);
  signal wr_dat_d0                      : std_logic_vector(31 downto 0);
begin

  -- AW, W and B channels
  awready <= not axi_awset;
  wready <= not axi_wset;
  bvalid <= axi_wdone;
  process (aclk) begin
    if rising_edge(aclk) then
      if areset_n = '0' then
        wr_req <= '0';
        axi_awset <= '0';
        axi_wset <= '0';
        axi_wdone <= '0';
      else
        wr_req <= '0';
        if awvalid = '1' and axi_awset = '0' then
          wr_addr <= awaddr;
          axi_awset <= '1';
          wr_req <= axi_wset;
        end if;
        if wvalid = '1' and axi_wset = '0' then
          wr_data <= wdata;
          axi_wset <= '1';
          wr_req <= axi_awset or awvalid;
        end if;
        if (axi_wdone and bready) = '1' then
          axi_wset <= '0';
          axi_awset <= '0';
          axi_wdone <= '0';
        end if;
        if wr_ack = '1' then
          axi_wdone <= '1';
        end if;
      end if;
    end if;
  end process;
  bresp <= "00";

  -- AR and R channels
  arready <= not axi_arset;
  rvalid <= axi_rdone;
  process (aclk) begin
    if rising_edge(aclk) then
      if areset_n = '0' then
        rd_req <= '0';
        axi_arset <= '0';
        axi_rdone <= '0';
        rdata <= (others => '0');
      else
        rd_req <= '0';
        if arvalid = '1' and axi_arset = '0' then
          rd_addr <= araddr;
          axi_arset <= '1';
          rd_req <= '1';
        end if;
        if (axi_rdone and rready) = '1' then
          axi_arset <= '0';
          axi_rdone <= '0';
        end if;
        if rd_ack = '1' then
          axi_rdone <= '1';
          rdata <= rd_data;
        end if;
      end if;
    end if;
  end process;
  rresp <= "00";

  -- pipelining for wr-in+rd-out
  process (aclk) begin
    if rising_edge(aclk) then
      if areset_n = '0' then
        rd_ack <= '0';
        wr_req_d0 <= '0';
      else
        rd_ack <= rd_ack_d0;
        rd_data <= rd_dat_d0;
        wr_req_d0 <= wr_req;
        wr_adr_d0 <= wr_addr;
        wr_dat_d0 <= wr_data;
      end if;
    end if;
  end process;

  -- Register ident

  -- Register status
  status_sampling_o <= wr_dat_d0(2);
  status_ready_o <= wr_dat_d0(1);
  status_transfer_o <= wr_dat_d0(0);
  process (aclk) begin
    if rising_edge(aclk) then
      if areset_n = '0' then
        status_dma_done_reg <= '0';
        status_wack <= '0';
      else
        if status_wreq = '1' then
          status_dma_done_reg <= status_dma_done_i or (status_dma_done_reg and not wr_dat_d0(3));
        else
          status_dma_done_reg <= status_dma_done_i or status_dma_done_reg;
        end if;
        status_wack <= status_wreq;
      end if;
    end if;
  end process;

  -- Register control
  control_sw_trig_o <= control_sw_trig_reg;
  control_prbs_o <= control_prbs_reg;
  process (aclk) begin
    if rising_edge(aclk) then
      if areset_n = '0' then
        control_sw_trig_reg <= '0';
        control_prbs_reg <= '0';
        control_wack <= '0';
      else
        if control_wreq = '1' then
          control_sw_trig_reg <= wr_dat_d0(0);
          control_prbs_reg <= wr_dat_d0(1);
        else
          control_sw_trig_reg <= '0';
        end if;
        control_wack <= control_wreq;
      end if;
    end if;
  end process;

  -- Register config
  config_periph_off_o <= config_periph_off_reg;
  config_clk_sel_o <= config_clk_sel_reg;
  config_rst_n_o <= config_rst_n_reg;
  config_resync_o <= config_resync_reg;
  config_patterns_o <= config_patterns_reg;
  config_trig_en_o <= config_trig_en_reg;
  process (aclk) begin
    if rising_edge(aclk) then
      if areset_n = '0' then
        config_periph_off_reg <= "00000000";
        config_clk_sel_reg <= "00";
        config_rst_n_reg <= '0';
        config_resync_reg <= '0';
        config_patterns_reg <= '0';
        config_trig_en_reg <= '0';
        config_wack <= '0';
      else
        if config_wreq = '1' then
          config_periph_off_reg <= wr_dat_d0(15 downto 8);
          config_clk_sel_reg <= wr_dat_d0(6 downto 5);
          config_rst_n_reg <= wr_dat_d0(4);
          config_resync_reg <= wr_dat_d0(2);
          config_patterns_reg <= wr_dat_d0(1);
          config_trig_en_reg <= wr_dat_d0(0);
        else
          config_resync_reg <= '0';
        end if;
        config_wack <= config_wreq;
      end if;
    end if;
  end process;

  -- Register length
  length_o <= length_reg;
  process (aclk) begin
    if rising_edge(aclk) then
      if areset_n = '0' then
        length_reg <= "00000000000000000000000000000000";
        length_wack <= '0';
      else
        if length_wreq = '1' then
          length_reg <= wr_dat_d0;
        end if;
        length_wack <= length_wreq;
      end if;
    end if;
  end process;

  -- Register configs_0_address
  configs_0_address_o <= configs_0_address_reg;
  process (aclk) begin
    if rising_edge(aclk) then
      if areset_n = '0' then
        configs_0_address_reg <= "00000000000000000000000000000000";
        configs_0_address_wack <= '0';
      else
        if configs_0_address_wreq = '1' then
          configs_0_address_reg <= wr_dat_d0;
        end if;
        configs_0_address_wack <= configs_0_address_wreq;
      end if;
    end if;
  end process;

  -- Register configs_0_cur_address

  -- Register configs_0_status

  -- Register configs_1_address
  configs_1_address_o <= configs_1_address_reg;
  process (aclk) begin
    if rising_edge(aclk) then
      if areset_n = '0' then
        configs_1_address_reg <= "00000000000000000000000000000000";
        configs_1_address_wack <= '0';
      else
        if configs_1_address_wreq = '1' then
          configs_1_address_reg <= wr_dat_d0;
        end if;
        configs_1_address_wack <= configs_1_address_wreq;
      end if;
    end if;
  end process;

  -- Register configs_1_cur_address

  -- Register configs_1_status

  -- Register periph_stat1

  -- Register periph_stat2

  -- Register cmd_boards
  cmd_boards_sel_o <= cmd_boards_sel_reg;
  process (aclk) begin
    if rising_edge(aclk) then
      if areset_n = '0' then
        cmd_boards_sel_reg <= "00000000";
        cmd_boards_wack <= '0';
      else
        if cmd_boards_wreq = '1' then
          cmd_boards_sel_reg <= wr_dat_d0(7 downto 0);
        end if;
        cmd_boards_wack <= cmd_boards_wreq;
      end if;
    end if;
  end process;

  -- Register cmd_value
  cmd_value_o <= cmd_value_reg;
  process (aclk) begin
    if rising_edge(aclk) then
      if areset_n = '0' then
        cmd_value_reg <= "00000000000000000000000000000000";
        cmd_value_wack <= '0';
      else
        if cmd_value_wreq = '1' then
          cmd_value_reg <= wr_dat_d0;
        end if;
        cmd_value_wack <= cmd_value_wreq;
      end if;
    end if;
  end process;

  -- Register cmd_ctrl
  cmd_ctrl_send_o <= cmd_ctrl_send_reg;
  cmd_ctrl_exec_o <= cmd_ctrl_exec_reg;
  process (aclk) begin
    if rising_edge(aclk) then
      if areset_n = '0' then
        cmd_ctrl_send_reg <= '0';
        cmd_ctrl_exec_reg <= '0';
        cmd_ctrl_wack <= '0';
      else
        if cmd_ctrl_wreq = '1' then
          cmd_ctrl_send_reg <= wr_dat_d0(1);
          cmd_ctrl_exec_reg <= wr_dat_d0(0);
        else
          cmd_ctrl_send_reg <= '0';
          cmd_ctrl_exec_reg <= '0';
        end if;
        cmd_ctrl_wack <= cmd_ctrl_wreq;
      end if;
    end if;
  end process;

  -- Register cmd_status
  cmd_status_done_o <= wr_dat_d0(15 downto 8);
  cmd_status_err_o <= wr_dat_d0(0);

  -- Register cmd_reply_0_value

  -- Register cmd_reply_1_value

  -- Register cmd_reply_2_value

  -- Register cmd_reply_3_value

  -- Register cmd_reply_4_value

  -- Register cmd_reply_5_value

  -- Register cmd_reply_6_value

  -- Register cmd_reply_7_value

  -- Register stat_sel
  stat_sel_ch_o <= stat_sel_ch_reg;
  stat_sel_board_o <= stat_sel_board_reg;
  stat_sel_delay_o <= stat_sel_delay_reg;
  stat_sel_branch_o <= stat_sel_branch_reg;
  stat_sel_clear_o <= stat_sel_clear_reg;
  process (aclk) begin
    if rising_edge(aclk) then
      if areset_n = '0' then
        stat_sel_ch_reg <= "0000";
        stat_sel_board_reg <= "000";
        stat_sel_delay_reg <= '0';
        stat_sel_branch_reg <= '0';
        stat_sel_clear_reg <= '0';
        stat_sel_wack <= '0';
      else
        if stat_sel_wreq = '1' then
          stat_sel_ch_reg <= wr_dat_d0(3 downto 0);
          stat_sel_board_reg <= wr_dat_d0(6 downto 4);
          stat_sel_delay_reg <= wr_dat_d0(8);
          stat_sel_branch_reg <= wr_dat_d0(9);
          stat_sel_clear_reg <= wr_dat_d0(31);
        else
          stat_sel_clear_reg <= '0';
        end if;
        stat_sel_wack <= stat_sel_wreq;
      end if;
    end if;
  end process;

  -- Register stat_clock

  -- Register stat_bit_lock

  -- Register stat_byte_lock

  -- Register stat_prbs

  -- Register delay_ctrl
  delay_ctrl_vtc_en_o <= delay_ctrl_vtc_en_reg;
  delay_ctrl_freeze_o <= delay_ctrl_freeze_reg;
  delay_ctrl_inc_o <= delay_ctrl_inc_reg;
  delay_ctrl_dec_o <= delay_ctrl_dec_reg;
  process (aclk) begin
    if rising_edge(aclk) then
      if areset_n = '0' then
        delay_ctrl_vtc_en_reg <= '1';
        delay_ctrl_freeze_reg <= '0';
        delay_ctrl_inc_reg <= '0';
        delay_ctrl_dec_reg <= '0';
        delay_ctrl_wack <= '0';
      else
        if delay_ctrl_wreq = '1' then
          delay_ctrl_vtc_en_reg <= wr_dat_d0(0);
          delay_ctrl_freeze_reg <= wr_dat_d0(1);
          delay_ctrl_inc_reg <= wr_dat_d0(4);
          delay_ctrl_dec_reg <= wr_dat_d0(5);
        else
          delay_ctrl_inc_reg <= '0';
          delay_ctrl_dec_reg <= '0';
        end if;
        delay_ctrl_wack <= delay_ctrl_wreq;
      end if;
    end if;
  end process;

  -- Register delay_cntvalue

  -- Process for write requests.
  process (wr_adr_d0, wr_req_d0, status_wack, control_wack, config_wack, length_wack, configs_0_address_wack, configs_1_address_wack, cmd_boards_wack, cmd_value_wack, cmd_ctrl_wack, stat_sel_wack, delay_ctrl_wack) begin
    status_wreq <= '0';
    control_wreq <= '0';
    config_wreq <= '0';
    length_wreq <= '0';
    configs_0_address_wreq <= '0';
    configs_1_address_wreq <= '0';
    cmd_boards_wreq <= '0';
    cmd_value_wreq <= '0';
    cmd_ctrl_wreq <= '0';
    stat_sel_wreq <= '0';
    delay_ctrl_wreq <= '0';
    case wr_adr_d0(7 downto 3) is
    when "00000" =>
      case wr_adr_d0(2 downto 2) is
      when "0" =>
        -- Reg ident
        wr_ack <= wr_req_d0;
      when "1" =>
        -- Reg status
        status_wreq <= wr_req_d0;
        wr_ack <= status_wack;
      when others =>
        wr_ack <= wr_req_d0;
      end case;
    when "00001" =>
      case wr_adr_d0(2 downto 2) is
      when "0" =>
        -- Reg control
        control_wreq <= wr_req_d0;
        wr_ack <= control_wack;
      when "1" =>
        -- Reg config
        config_wreq <= wr_req_d0;
        wr_ack <= config_wack;
      when others =>
        wr_ack <= wr_req_d0;
      end case;
    when "00010" =>
      case wr_adr_d0(2 downto 2) is
      when "0" =>
        -- Reg length
        length_wreq <= wr_req_d0;
        wr_ack <= length_wack;
      when others =>
        wr_ack <= wr_req_d0;
      end case;
    when "00100" =>
      case wr_adr_d0(2 downto 2) is
      when "0" =>
        -- Reg configs_0_address
        configs_0_address_wreq <= wr_req_d0;
        wr_ack <= configs_0_address_wack;
      when "1" =>
        -- Reg configs_0_cur_address
        wr_ack <= wr_req_d0;
      when others =>
        wr_ack <= wr_req_d0;
      end case;
    when "00101" =>
      case wr_adr_d0(2 downto 2) is
      when "0" =>
        -- Reg configs_0_status
        wr_ack <= wr_req_d0;
      when "1" =>
        -- Reg configs_1_address
        configs_1_address_wreq <= wr_req_d0;
        wr_ack <= configs_1_address_wack;
      when others =>
        wr_ack <= wr_req_d0;
      end case;
    when "00110" =>
      case wr_adr_d0(2 downto 2) is
      when "0" =>
        -- Reg configs_1_cur_address
        wr_ack <= wr_req_d0;
      when "1" =>
        -- Reg configs_1_status
        wr_ack <= wr_req_d0;
      when others =>
        wr_ack <= wr_req_d0;
      end case;
    when "01000" =>
      case wr_adr_d0(2 downto 2) is
      when "0" =>
        -- Reg periph_stat1
        wr_ack <= wr_req_d0;
      when "1" =>
        -- Reg periph_stat2
        wr_ack <= wr_req_d0;
      when others =>
        wr_ack <= wr_req_d0;
      end case;
    when "01001" =>
      case wr_adr_d0(2 downto 2) is
      when "0" =>
        -- Reg cmd_boards
        cmd_boards_wreq <= wr_req_d0;
        wr_ack <= cmd_boards_wack;
      when "1" =>
        -- Reg cmd_value
        cmd_value_wreq <= wr_req_d0;
        wr_ack <= cmd_value_wack;
      when others =>
        wr_ack <= wr_req_d0;
      end case;
    when "01010" =>
      case wr_adr_d0(2 downto 2) is
      when "0" =>
        -- Reg cmd_ctrl
        cmd_ctrl_wreq <= wr_req_d0;
        wr_ack <= cmd_ctrl_wack;
      when "1" =>
        -- Reg cmd_status
        wr_ack <= wr_req_d0;
      when others =>
        wr_ack <= wr_req_d0;
      end case;
    when "01100" =>
      case wr_adr_d0(2 downto 2) is
      when "0" =>
        -- Reg cmd_reply_0_value
        wr_ack <= wr_req_d0;
      when "1" =>
        -- Reg cmd_reply_1_value
        wr_ack <= wr_req_d0;
      when others =>
        wr_ack <= wr_req_d0;
      end case;
    when "01101" =>
      case wr_adr_d0(2 downto 2) is
      when "0" =>
        -- Reg cmd_reply_2_value
        wr_ack <= wr_req_d0;
      when "1" =>
        -- Reg cmd_reply_3_value
        wr_ack <= wr_req_d0;
      when others =>
        wr_ack <= wr_req_d0;
      end case;
    when "01110" =>
      case wr_adr_d0(2 downto 2) is
      when "0" =>
        -- Reg cmd_reply_4_value
        wr_ack <= wr_req_d0;
      when "1" =>
        -- Reg cmd_reply_5_value
        wr_ack <= wr_req_d0;
      when others =>
        wr_ack <= wr_req_d0;
      end case;
    when "01111" =>
      case wr_adr_d0(2 downto 2) is
      when "0" =>
        -- Reg cmd_reply_6_value
        wr_ack <= wr_req_d0;
      when "1" =>
        -- Reg cmd_reply_7_value
        wr_ack <= wr_req_d0;
      when others =>
        wr_ack <= wr_req_d0;
      end case;
    when "10000" =>
      case wr_adr_d0(2 downto 2) is
      when "0" =>
        -- Reg stat_sel
        stat_sel_wreq <= wr_req_d0;
        wr_ack <= stat_sel_wack;
      when others =>
        wr_ack <= wr_req_d0;
      end case;
    when "10001" =>
      case wr_adr_d0(2 downto 2) is
      when "0" =>
        -- Reg stat_clock
        wr_ack <= wr_req_d0;
      when "1" =>
        -- Reg stat_clock
        wr_ack <= wr_req_d0;
      when others =>
        wr_ack <= wr_req_d0;
      end case;
    when "10010" =>
      case wr_adr_d0(2 downto 2) is
      when "0" =>
        -- Reg stat_bit_lock
        wr_ack <= wr_req_d0;
      when "1" =>
        -- Reg stat_byte_lock
        wr_ack <= wr_req_d0;
      when others =>
        wr_ack <= wr_req_d0;
      end case;
    when "10011" =>
      case wr_adr_d0(2 downto 2) is
      when "0" =>
        -- Reg stat_prbs
        wr_ack <= wr_req_d0;
      when "1" =>
        -- Reg delay_ctrl
        delay_ctrl_wreq <= wr_req_d0;
        wr_ack <= delay_ctrl_wack;
      when others =>
        wr_ack <= wr_req_d0;
      end case;
    when "10100" =>
      case wr_adr_d0(2 downto 2) is
      when "0" =>
        -- Reg delay_cntvalue
        wr_ack <= wr_req_d0;
      when others =>
        wr_ack <= wr_req_d0;
      end case;
    when others =>
      wr_ack <= wr_req_d0;
    end case;
  end process;

  -- Process for read requests.
  process (rd_addr, rd_req, status_transfer_i, status_ready_i, status_sampling_i, status_dma_done_reg, control_prbs_reg, config_trig_en_reg, config_patterns_reg, config_rst_n_reg, config_clk_sel_reg, config_periph_off_reg, length_reg, configs_0_address_reg, configs_0_cur_address_i, configs_0_status_axi_i, configs_0_status_fifo_max_i, configs_0_status_fifo_errs_i, configs_1_address_reg, configs_1_cur_address_i, configs_1_status_axi_i, configs_1_status_fifo_max_i, configs_1_status_fifo_errs_i, periph_stat1_inp_i, periph_stat1_triggers_i, periph_stat1_spi_busy_i, periph_stat2_rx_locked_i, periph_stat2_adc_locked_i, periph_stat2_sys_locked_i, periph_stat2_fsi_ready_i, cmd_boards_sel_reg, cmd_value_reg, cmd_status_err_i, cmd_status_done_i, cmd_reply_0_value_i, cmd_reply_1_value_i, cmd_reply_2_value_i, cmd_reply_3_value_i, cmd_reply_4_value_i, cmd_reply_5_value_i, cmd_reply_6_value_i, cmd_reply_7_value_i, stat_sel_ch_reg, stat_sel_board_reg, stat_sel_delay_reg, stat_sel_branch_reg, stat_clock_i, stat_bit_lock_i, stat_byte_lock_i, stat_prbs_i, delay_ctrl_vtc_en_reg, delay_ctrl_freeze_reg, delay_cntvalue_i) begin
    -- By default ack read requests
    rd_dat_d0 <= (others => 'X');
    case rd_addr(7 downto 3) is
    when "00000" =>
      case rd_addr(2 downto 2) is
      when "0" =>
        -- Reg ident
        rd_ack_d0 <= rd_req;
        rd_dat_d0 <= "01000110010100110100100100110010";
      when "1" =>
        -- Reg status
        rd_ack_d0 <= rd_req;
        rd_dat_d0(0) <= status_transfer_i;
        rd_dat_d0(1) <= status_ready_i;
        rd_dat_d0(2) <= status_sampling_i;
        rd_dat_d0(3) <= status_dma_done_reg;
        rd_dat_d0(31 downto 4) <= (others => '0');
      when others =>
        rd_ack_d0 <= rd_req;
      end case;
    when "00001" =>
      case rd_addr(2 downto 2) is
      when "0" =>
        -- Reg control
        rd_ack_d0 <= rd_req;
        rd_dat_d0(0) <= '0';
        rd_dat_d0(1) <= control_prbs_reg;
        rd_dat_d0(31 downto 2) <= (others => '0');
      when "1" =>
        -- Reg config
        rd_ack_d0 <= rd_req;
        rd_dat_d0(0) <= config_trig_en_reg;
        rd_dat_d0(1) <= config_patterns_reg;
        rd_dat_d0(2) <= '0';
        rd_dat_d0(3) <= '0';
        rd_dat_d0(4) <= config_rst_n_reg;
        rd_dat_d0(6 downto 5) <= config_clk_sel_reg;
        rd_dat_d0(7) <= '0';
        rd_dat_d0(15 downto 8) <= config_periph_off_reg;
        rd_dat_d0(31 downto 16) <= (others => '0');
      when others =>
        rd_ack_d0 <= rd_req;
      end case;
    when "00010" =>
      case rd_addr(2 downto 2) is
      when "0" =>
        -- Reg length
        rd_ack_d0 <= rd_req;
        rd_dat_d0 <= length_reg;
      when others =>
        rd_ack_d0 <= rd_req;
      end case;
    when "00100" =>
      case rd_addr(2 downto 2) is
      when "0" =>
        -- Reg configs_0_address
        rd_ack_d0 <= rd_req;
        rd_dat_d0 <= configs_0_address_reg;
      when "1" =>
        -- Reg configs_0_cur_address
        rd_ack_d0 <= rd_req;
        rd_dat_d0 <= configs_0_cur_address_i;
      when others =>
        rd_ack_d0 <= rd_req;
      end case;
    when "00101" =>
      case rd_addr(2 downto 2) is
      when "0" =>
        -- Reg configs_0_status
        rd_ack_d0 <= rd_req;
        rd_dat_d0(3 downto 0) <= configs_0_status_axi_i;
        rd_dat_d0(7 downto 4) <= (others => '0');
        rd_dat_d0(15 downto 8) <= configs_0_status_fifo_max_i;
        rd_dat_d0(23 downto 16) <= configs_0_status_fifo_errs_i;
        rd_dat_d0(31 downto 24) <= (others => '0');
      when "1" =>
        -- Reg configs_1_address
        rd_ack_d0 <= rd_req;
        rd_dat_d0 <= configs_1_address_reg;
      when others =>
        rd_ack_d0 <= rd_req;
      end case;
    when "00110" =>
      case rd_addr(2 downto 2) is
      when "0" =>
        -- Reg configs_1_cur_address
        rd_ack_d0 <= rd_req;
        rd_dat_d0 <= configs_1_cur_address_i;
      when "1" =>
        -- Reg configs_1_status
        rd_ack_d0 <= rd_req;
        rd_dat_d0(3 downto 0) <= configs_1_status_axi_i;
        rd_dat_d0(7 downto 4) <= (others => '0');
        rd_dat_d0(15 downto 8) <= configs_1_status_fifo_max_i;
        rd_dat_d0(23 downto 16) <= configs_1_status_fifo_errs_i;
        rd_dat_d0(31 downto 24) <= (others => '0');
      when others =>
        rd_ack_d0 <= rd_req;
      end case;
    when "01000" =>
      case rd_addr(2 downto 2) is
      when "0" =>
        -- Reg periph_stat1
        rd_ack_d0 <= rd_req;
        rd_dat_d0(7 downto 0) <= periph_stat1_inp_i;
        rd_dat_d0(15 downto 8) <= periph_stat1_triggers_i;
        rd_dat_d0(23 downto 16) <= periph_stat1_spi_busy_i;
        rd_dat_d0(31 downto 24) <= (others => '0');
      when "1" =>
        -- Reg periph_stat2
        rd_ack_d0 <= rd_req;
        rd_dat_d0(7 downto 0) <= periph_stat2_rx_locked_i;
        rd_dat_d0(15 downto 8) <= periph_stat2_adc_locked_i;
        rd_dat_d0(23 downto 16) <= periph_stat2_sys_locked_i;
        rd_dat_d0(31 downto 24) <= periph_stat2_fsi_ready_i;
      when others =>
        rd_ack_d0 <= rd_req;
      end case;
    when "01001" =>
      case rd_addr(2 downto 2) is
      when "0" =>
        -- Reg cmd_boards
        rd_ack_d0 <= rd_req;
        rd_dat_d0(7 downto 0) <= cmd_boards_sel_reg;
        rd_dat_d0(31 downto 8) <= (others => '0');
      when "1" =>
        -- Reg cmd_value
        rd_ack_d0 <= rd_req;
        rd_dat_d0 <= cmd_value_reg;
      when others =>
        rd_ack_d0 <= rd_req;
      end case;
    when "01010" =>
      case rd_addr(2 downto 2) is
      when "0" =>
        -- Reg cmd_ctrl
        rd_ack_d0 <= rd_req;
      when "1" =>
        -- Reg cmd_status
        rd_ack_d0 <= rd_req;
        rd_dat_d0(0) <= cmd_status_err_i;
        rd_dat_d0(7 downto 1) <= (others => '0');
        rd_dat_d0(15 downto 8) <= cmd_status_done_i;
        rd_dat_d0(31 downto 16) <= (others => '0');
      when others =>
        rd_ack_d0 <= rd_req;
      end case;
    when "01100" =>
      case rd_addr(2 downto 2) is
      when "0" =>
        -- Reg cmd_reply_0_value
        rd_ack_d0 <= rd_req;
        rd_dat_d0 <= cmd_reply_0_value_i;
      when "1" =>
        -- Reg cmd_reply_1_value
        rd_ack_d0 <= rd_req;
        rd_dat_d0 <= cmd_reply_1_value_i;
      when others =>
        rd_ack_d0 <= rd_req;
      end case;
    when "01101" =>
      case rd_addr(2 downto 2) is
      when "0" =>
        -- Reg cmd_reply_2_value
        rd_ack_d0 <= rd_req;
        rd_dat_d0 <= cmd_reply_2_value_i;
      when "1" =>
        -- Reg cmd_reply_3_value
        rd_ack_d0 <= rd_req;
        rd_dat_d0 <= cmd_reply_3_value_i;
      when others =>
        rd_ack_d0 <= rd_req;
      end case;
    when "01110" =>
      case rd_addr(2 downto 2) is
      when "0" =>
        -- Reg cmd_reply_4_value
        rd_ack_d0 <= rd_req;
        rd_dat_d0 <= cmd_reply_4_value_i;
      when "1" =>
        -- Reg cmd_reply_5_value
        rd_ack_d0 <= rd_req;
        rd_dat_d0 <= cmd_reply_5_value_i;
      when others =>
        rd_ack_d0 <= rd_req;
      end case;
    when "01111" =>
      case rd_addr(2 downto 2) is
      when "0" =>
        -- Reg cmd_reply_6_value
        rd_ack_d0 <= rd_req;
        rd_dat_d0 <= cmd_reply_6_value_i;
      when "1" =>
        -- Reg cmd_reply_7_value
        rd_ack_d0 <= rd_req;
        rd_dat_d0 <= cmd_reply_7_value_i;
      when others =>
        rd_ack_d0 <= rd_req;
      end case;
    when "10000" =>
      case rd_addr(2 downto 2) is
      when "0" =>
        -- Reg stat_sel
        rd_ack_d0 <= rd_req;
        rd_dat_d0(3 downto 0) <= stat_sel_ch_reg;
        rd_dat_d0(6 downto 4) <= stat_sel_board_reg;
        rd_dat_d0(7) <= '0';
        rd_dat_d0(8) <= stat_sel_delay_reg;
        rd_dat_d0(9) <= stat_sel_branch_reg;
        rd_dat_d0(30 downto 10) <= (others => '0');
        rd_dat_d0(31) <= '0';
      when others =>
        rd_ack_d0 <= rd_req;
      end case;
    when "10001" =>
      case rd_addr(2 downto 2) is
      when "0" =>
        -- Reg stat_clock
        rd_ack_d0 <= rd_req;
        rd_dat_d0 <= stat_clock_i(31 downto 0);
      when "1" =>
        -- Reg stat_clock
        rd_ack_d0 <= rd_req;
        rd_dat_d0 <= stat_clock_i(63 downto 32);
      when others =>
        rd_ack_d0 <= rd_req;
      end case;
    when "10010" =>
      case rd_addr(2 downto 2) is
      when "0" =>
        -- Reg stat_bit_lock
        rd_ack_d0 <= rd_req;
        rd_dat_d0 <= stat_bit_lock_i;
      when "1" =>
        -- Reg stat_byte_lock
        rd_ack_d0 <= rd_req;
        rd_dat_d0 <= stat_byte_lock_i;
      when others =>
        rd_ack_d0 <= rd_req;
      end case;
    when "10011" =>
      case rd_addr(2 downto 2) is
      when "0" =>
        -- Reg stat_prbs
        rd_ack_d0 <= rd_req;
        rd_dat_d0 <= stat_prbs_i;
      when "1" =>
        -- Reg delay_ctrl
        rd_ack_d0 <= rd_req;
        rd_dat_d0(0) <= delay_ctrl_vtc_en_reg;
        rd_dat_d0(1) <= delay_ctrl_freeze_reg;
        rd_dat_d0(3 downto 2) <= (others => '0');
        rd_dat_d0(4) <= '0';
        rd_dat_d0(5) <= '0';
        rd_dat_d0(31 downto 6) <= (others => '0');
      when others =>
        rd_ack_d0 <= rd_req;
      end case;
    when "10100" =>
      case rd_addr(2 downto 2) is
      when "0" =>
        -- Reg delay_cntvalue
        rd_ack_d0 <= rd_req;
        rd_dat_d0 <= delay_cntvalue_i;
      when others =>
        rd_ack_d0 <= rd_req;
      end case;
    when others =>
      rd_ack_d0 <= rd_req;
    end case;
  end process;
end syn;
