set_property CONFIG_MODE SPIx4 [current_design]
set_property CFGBVS VCCO [current_design]
set_property CONFIG_VOLTAGE 3.3 [current_design]

# Bank 14 HR (3.3V)
set_property PACKAGE_PIN M16 [get_ports fpga_reset_n_i]
set_property IOSTANDARD LVCMOS33 [get_ports fpga_reset_n_i]

set_property PACKAGE_PIN T10 [get_ports afe_tia_ctrl_o[8]]
set_property PACKAGE_PIN T9  [get_ports afe_tia_ctrl_o[7]]
set_property PACKAGE_PIN R8  [get_ports afe_tia_ctrl_o[6]]
set_property PACKAGE_PIN R7  [get_ports afe_tia_ctrl_o[5]]
set_property PACKAGE_PIN T7  [get_ports afe_tia_ctrl_o[4]]
set_property PACKAGE_PIN R6  [get_ports afe_tia_ctrl_o[3]]
set_property PACKAGE_PIN T5  [get_ports afe_tia_ctrl_o[2]]
set_property PACKAGE_PIN R5  [get_ports afe_tia_ctrl_o[1]]

set_property IOSTANDARD LVCMOS33 [get_ports afe_tia_ctrl_o[8]]
set_property IOSTANDARD LVCMOS33 [get_ports afe_tia_ctrl_o[7]]
set_property IOSTANDARD LVCMOS33 [get_ports afe_tia_ctrl_o[6]]
set_property IOSTANDARD LVCMOS33 [get_ports afe_tia_ctrl_o[5]]
set_property IOSTANDARD LVCMOS33 [get_ports afe_tia_ctrl_o[4]]
set_property IOSTANDARD LVCMOS33 [get_ports afe_tia_ctrl_o[3]]
set_property IOSTANDARD LVCMOS33 [get_ports afe_tia_ctrl_o[2]]
set_property IOSTANDARD LVCMOS33 [get_ports afe_tia_ctrl_o[1]]

set_property PACKAGE_PIN R12 [get_ports bp_sda_b]
set_property PACKAGE_PIN T12 [get_ports bp_scl_i]
set_property IOSTANDARD LVCMOS33 [get_ports bp_sda_b]
set_property IOSTANDARD LVCMOS33 [get_ports bp_scl_i]

set_property PACKAGE_PIN T8 [get_ports led0_o]
set_property PACKAGE_PIN P9 [get_ports led1_o]
set_property IOSTANDARD LVCMOS33 [get_ports led0_o]
set_property IOSTANDARD LVCMOS33 [get_ports led1_o]

set_property PACKAGE_PIN N14 [get_ports trigger_p_i]
set_property PACKAGE_PIN P14 [get_ports trigger_n_i]
set_property IOSTANDARD LVDS_25 [get_ports trigger_p_i]
set_property IOSTANDARD LVDS_25 [get_ports trigger_n_i]
set_property DIFF_TERM FALSE [get_ports trigger_p_i]
set_property DIFF_TERM FALSE [get_ports trigger_n_i]

#set_property PACKAGE_PIN K16 [get_ports qspi_dq[3]]
#set_property PACKAGE_PIN K15 [get_ports qspi_dq[2]]
#set_property PACKAGE_PIN J14 [get_ports qspi_dq[1]]
#set_property PACKAGE_PIN J13 [get_ports qspi_dq[0]]
#set_property PACKAGE_PIN L12 [get_ports qspi_cs_n]
#set_property PACKAGE_PIN E8 [get_ports qspi_clk]

#set_property PACKAGE_PIN K10 [get_ports NetIC8_K10] # INIT
#set_property PACKAGE_PIN M7 [get_ports JTAG_TMS]
#set_property PACKAGE_PIN N8 [get_ports JTAG_TDO]
#set_property PACKAGE_PIN N7 [get_ports JTAG_TDI]
#set_property PACKAGE_PIN L7 [get_ports JTAG_TCK]

#set_property PACKAGE_PIN L15 [get_ports FPGA_PUDC#]
#set_property PACKAGE_PIN L9 [get_ports FPGA_PROG_B]
#set_property PACKAGE_PIN M11 [get_ports FPGA_MODE2]
#set_property PACKAGE_PIN M9 [get_ports FPGA_MODE0]
#set_property PACKAGE_PIN H10 [get_ports FPGA_DONE]

# Bank 15 HR (LVDS 1.8V)
set_property PACKAGE_PIN D13 [get_ports fpga_clk_p_i]
set_property PACKAGE_PIN C13 [get_ports fpga_clk_n_i]

set_property IOSTANDARD LVDS_25 [get_ports fpga_clk_p_i]
set_property IOSTANDARD LVDS_25 [get_ports fpga_clk_n_i]
set_property DIFF_TERM FALSE [get_ports fpga_clk_p_i]
set_property DIFF_TERM FALSE [get_ports fpga_clk_n_i]

# Note: the assignment between fpga pins and backplane lanes is done
# here.  This is the original pin mapping.
#set_property PACKAGE_PIN B9  [get_ports bp_io_p_o[14]]
#set_property PACKAGE_PIN A10 [get_ports bp_io_n_o[14]]
#set_property PACKAGE_PIN A8  [get_ports bp_io_p_o[13]]
#set_property PACKAGE_PIN A9  [get_ports bp_io_n_o[13]]
#set_property PACKAGE_PIN B12 [get_ports bp_io_p_o[12]]
#set_property PACKAGE_PIN A12 [get_ports bp_io_n_o[12]]
#set_property PACKAGE_PIN B10 [get_ports bp_io_p_o[11]]
#set_property PACKAGE_PIN B11 [get_ports bp_io_n_o[11]]
#set_property PACKAGE_PIN C8  [get_ports bp_io_p_o[10]]
#set_property PACKAGE_PIN C9  [get_ports bp_io_n_o[10]]
#set_property PACKAGE_PIN C11 [get_ports bp_io_p_o[9]]
#set_property PACKAGE_PIN C12 [get_ports bp_io_n_o[9]]
#set_property PACKAGE_PIN A13 [get_ports bp_io_p_o[8]]
#set_property PACKAGE_PIN A14 [get_ports bp_io_n_o[8]]
#set_property PACKAGE_PIN B15 [get_ports bp_io_p_o[7]]
#set_property PACKAGE_PIN A15 [get_ports bp_io_n_o[7]]
#set_property PACKAGE_PIN C14 [get_ports bp_io_p_o[6]]
#set_property PACKAGE_PIN B14 [get_ports bp_io_n_o[6]]
#set_property PACKAGE_PIN C16 [get_ports bp_io_p_o[5]]
#set_property PACKAGE_PIN B16 [get_ports bp_io_n_o[5]]
#set_property PACKAGE_PIN F15 [get_ports bp_io_p_o[4]]
#set_property PACKAGE_PIN E15 [get_ports bp_io_n_o[4]]
#set_property PACKAGE_PIN E12 [get_ports bp_io_p_o[3]]
#set_property PACKAGE_PIN E13 [get_ports bp_io_n_o[3]]
#set_property PACKAGE_PIN D14 [get_ports bp_io_p_o[2]]
#set_property PACKAGE_PIN D15 [get_ports bp_io_n_o[2]]
#set_property PACKAGE_PIN H16 [get_ports bp_io_p_o[1]]
#set_property PACKAGE_PIN G16 [get_ports bp_io_n_o[1]]
#set_property PACKAGE_PIN J15 [get_ports bp_io_p_o[0]]
#set_property PACKAGE_PIN J16 [get_ports bp_io_n_o[0]]

# This is the mapping.
set_property PACKAGE_PIN B9  [get_ports bp_io_p_i[1]];   # lane 14
set_property PACKAGE_PIN A10 [get_ports bp_io_n_i[1]]
set_property PACKAGE_PIN A8  [get_ports bp_io_p_i[0]];   # lane 13
set_property PACKAGE_PIN A9  [get_ports bp_io_n_i[0]]
set_property PACKAGE_PIN B12 [get_ports bp_io_p_o[12]];	 # lane 12
set_property PACKAGE_PIN A12 [get_ports bp_io_n_o[12]]
set_property PACKAGE_PIN B10 [get_ports bp_io_p_o[11]];  # lane 11
set_property PACKAGE_PIN B11 [get_ports bp_io_n_o[11]]
set_property PACKAGE_PIN C8  [get_ports bp_io_p_o[10]];  # lane 10
set_property PACKAGE_PIN C9  [get_ports bp_io_n_o[10]]
set_property PACKAGE_PIN C11 [get_ports bp_io_p_o[9]];   # lane 9
set_property PACKAGE_PIN C12 [get_ports bp_io_n_o[9]]
set_property PACKAGE_PIN A13 [get_ports bp_io_p_o[8]];   # lane 8
set_property PACKAGE_PIN A14 [get_ports bp_io_n_o[8]]
set_property PACKAGE_PIN B15 [get_ports bp_io_p_o[7]];   # lane 7
set_property PACKAGE_PIN A15 [get_ports bp_io_n_o[7]]
set_property PACKAGE_PIN C14 [get_ports bp_io_p_o[6]];   # lane 6
set_property PACKAGE_PIN B14 [get_ports bp_io_n_o[6]]
set_property PACKAGE_PIN C16 [get_ports bp_io_p_o[5]];   # lane 5
set_property PACKAGE_PIN B16 [get_ports bp_io_n_o[5]]
set_property PACKAGE_PIN F15 [get_ports bp_io_p_o[4]];   # lane 4
set_property PACKAGE_PIN E15 [get_ports bp_io_n_o[4]]
set_property PACKAGE_PIN E12 [get_ports bp_io_p_o[3]];   # lane 3
set_property PACKAGE_PIN E13 [get_ports bp_io_n_o[3]]
set_property PACKAGE_PIN D14 [get_ports bp_io_p_o[2]];   # lane 2
set_property PACKAGE_PIN D15 [get_ports bp_io_n_o[2]]
set_property PACKAGE_PIN H16 [get_ports bp_io_p_o[1]];   # lane 1
set_property PACKAGE_PIN G16 [get_ports bp_io_n_o[1]]
set_property PACKAGE_PIN J15 [get_ports bp_io_p_o[0]];   # lane 0
set_property PACKAGE_PIN J16 [get_ports bp_io_n_o[0]]

set_property IOSTANDARD LVDS_25 [get_ports bp_io_p_i[0]]
set_property IOSTANDARD LVDS_25 [get_ports bp_io_n_i[0]]
set_property IOSTANDARD LVDS_25 [get_ports bp_io_p_o[3]]
set_property IOSTANDARD LVDS_25 [get_ports bp_io_n_o[3]]
set_property IOSTANDARD LVDS_25 [get_ports bp_io_p_o[12]]
set_property IOSTANDARD LVDS_25 [get_ports bp_io_n_o[12]]
set_property IOSTANDARD LVDS_25 [get_ports bp_io_p_o[11]]
set_property IOSTANDARD LVDS_25 [get_ports bp_io_n_o[11]]
set_property IOSTANDARD LVDS_25 [get_ports bp_io_p_o[10]]
set_property IOSTANDARD LVDS_25 [get_ports bp_io_n_o[10]]
set_property IOSTANDARD LVDS_25 [get_ports bp_io_p_o[9]]
set_property IOSTANDARD LVDS_25 [get_ports bp_io_n_o[9]]
set_property IOSTANDARD LVDS_25 [get_ports bp_io_p_o[8]]
set_property IOSTANDARD LVDS_25 [get_ports bp_io_n_o[8]]
set_property IOSTANDARD LVDS_25 [get_ports bp_io_p_o[7]]
set_property IOSTANDARD LVDS_25 [get_ports bp_io_n_o[7]]
set_property IOSTANDARD LVDS_25 [get_ports bp_io_p_o[6]]
set_property IOSTANDARD LVDS_25 [get_ports bp_io_n_o[6]]
set_property IOSTANDARD LVDS_25 [get_ports bp_io_p_o[5]]
set_property IOSTANDARD LVDS_25 [get_ports bp_io_n_o[5]]
set_property IOSTANDARD LVDS_25 [get_ports bp_io_p_o[4]]
set_property IOSTANDARD LVDS_25 [get_ports bp_io_n_o[4]]
set_property IOSTANDARD LVDS_25 [get_ports bp_io_p_i[1]]
set_property IOSTANDARD LVDS_25 [get_ports bp_io_n_i[1]]
set_property IOSTANDARD LVDS_25 [get_ports bp_io_p_o[2]]
set_property IOSTANDARD LVDS_25 [get_ports bp_io_n_o[2]]
set_property IOSTANDARD LVDS_25 [get_ports bp_io_p_o[1]]
set_property IOSTANDARD LVDS_25 [get_ports bp_io_n_o[1]]
set_property IOSTANDARD LVDS_25 [get_ports bp_io_p_o[0]]
set_property IOSTANDARD LVDS_25 [get_ports bp_io_n_o[0]]

# Note: DIFF_TERM is meaningful only for inputs.
set_property DIFF_TERM FALSE [get_ports bp_io_p_i[0]]
set_property DIFF_TERM FALSE [get_ports bp_io_n_i[0]]
set_property DIFF_TERM FALSE [get_ports bp_io_p_i[1]]
set_property DIFF_TERM FALSE [get_ports bp_io_n_i[1]]

# Bank 34 HR (1.8V)
set_property PACKAGE_PIN R1 [get_ports adc_sync_o]
set_property PACKAGE_PIN T2 [get_ports adc_sdout_i]
set_property PACKAGE_PIN N2 [get_ports adc_sdata_o]
set_property PACKAGE_PIN N1 [get_ports adc_sclk_o]
set_property PACKAGE_PIN M2 [get_ports adc_reset_o]
set_property PACKAGE_PIN M1 [get_ports adc_pd_o]
set_property PACKAGE_PIN P1 [get_ports adc_cs_n_o]

set_property IOSTANDARD LVCMOS18 [get_ports adc_sync_o]
set_property IOSTANDARD LVCMOS18 [get_ports adc_sdout_i]
set_property IOSTANDARD LVCMOS18 [get_ports adc_sdata_o]
set_property IOSTANDARD LVCMOS18 [get_ports adc_sclk_o]
set_property IOSTANDARD LVCMOS18 [get_ports adc_reset_o]
set_property IOSTANDARD LVCMOS18 [get_ports adc_pd_o]
set_property IOSTANDARD LVCMOS18 [get_ports adc_cs_n_o]

# Bank 35 HR (2.5V)
set_property PACKAGE_PIN A5 [get_ports adc_outb_p_i[7]]
set_property PACKAGE_PIN B2 [get_ports adc_outb_p_i[6]]
set_property PACKAGE_PIN H2 [get_ports adc_outb_p_i[5]]
set_property PACKAGE_PIN B6 [get_ports adc_outb_p_i[4]]
set_property PACKAGE_PIN C1 [get_ports adc_outb_p_i[3]]
set_property PACKAGE_PIN F2 [get_ports adc_outb_p_i[2]]
set_property PACKAGE_PIN H5 [get_ports adc_outb_p_i[1]]
set_property PACKAGE_PIN K3 [get_ports adc_outb_p_i[0]]
set_property PACKAGE_PIN A4 [get_ports adc_outb_n_i[7]]
set_property PACKAGE_PIN A2 [get_ports adc_outb_n_i[6]]
set_property PACKAGE_PIN H1 [get_ports adc_outb_n_i[5]]
set_property PACKAGE_PIN B5 [get_ports adc_outb_n_i[4]]
set_property PACKAGE_PIN B1 [get_ports adc_outb_n_i[3]]
set_property PACKAGE_PIN E1 [get_ports adc_outb_n_i[2]]
set_property PACKAGE_PIN H4 [get_ports adc_outb_n_i[1]]
set_property PACKAGE_PIN K2 [get_ports adc_outb_n_i[0]]
set_property PACKAGE_PIN B7 [get_ports adc_outa_p_i[7]]
set_property PACKAGE_PIN B4 [get_ports adc_outa_p_i[6]]
set_property PACKAGE_PIN G2 [get_ports adc_outa_p_i[5]]
set_property PACKAGE_PIN C7 [get_ports adc_outa_p_i[4]]
set_property PACKAGE_PIN E2 [get_ports adc_outa_p_i[3]]
set_property PACKAGE_PIN G5 [get_ports adc_outa_p_i[2]]
set_property PACKAGE_PIN J3 [get_ports adc_outa_p_i[1]]
set_property PACKAGE_PIN L3 [get_ports adc_outa_p_i[0]]
set_property PACKAGE_PIN A7 [get_ports adc_outa_n_i[7]]
set_property PACKAGE_PIN A3 [get_ports adc_outa_n_i[6]]
set_property PACKAGE_PIN G1 [get_ports adc_outa_n_i[5]]
set_property PACKAGE_PIN C6 [get_ports adc_outa_n_i[4]]
set_property PACKAGE_PIN D1 [get_ports adc_outa_n_i[3]]
set_property PACKAGE_PIN G4 [get_ports adc_outa_n_i[2]]
set_property PACKAGE_PIN H3 [get_ports adc_outa_n_i[1]]
set_property PACKAGE_PIN L2 [get_ports adc_outa_n_i[0]]
set_property PACKAGE_PIN D4 [get_ports adc_lclk_p_i]
set_property PACKAGE_PIN C4 [get_ports adc_lclk_n_i]
set_property PACKAGE_PIN F5 [get_ports adc_adclk_p_i]
set_property PACKAGE_PIN E5 [get_ports adc_adclk_n_i]

set_property IOSTANDARD LVDS_25 [get_ports adc_outb_p_i[7]]
set_property IOSTANDARD LVDS_25 [get_ports adc_outb_p_i[6]]
set_property IOSTANDARD LVDS_25 [get_ports adc_outb_p_i[5]]
set_property IOSTANDARD LVDS_25 [get_ports adc_outb_p_i[4]]
set_property IOSTANDARD LVDS_25 [get_ports adc_outb_p_i[3]]
set_property IOSTANDARD LVDS_25 [get_ports adc_outb_p_i[2]]
set_property IOSTANDARD LVDS_25 [get_ports adc_outb_p_i[1]]
set_property IOSTANDARD LVDS_25 [get_ports adc_outb_p_i[0]]
set_property IOSTANDARD LVDS_25 [get_ports adc_outb_n_i[7]]
set_property IOSTANDARD LVDS_25 [get_ports adc_outb_n_i[6]]
set_property IOSTANDARD LVDS_25 [get_ports adc_outb_n_i[5]]
set_property IOSTANDARD LVDS_25 [get_ports adc_outb_n_i[4]]
set_property IOSTANDARD LVDS_25 [get_ports adc_outb_n_i[3]]
set_property IOSTANDARD LVDS_25 [get_ports adc_outb_n_i[2]]
set_property IOSTANDARD LVDS_25 [get_ports adc_outb_n_i[1]]
set_property IOSTANDARD LVDS_25 [get_ports adc_outb_n_i[0]]
set_property IOSTANDARD LVDS_25 [get_ports adc_outa_p_i[7]]
set_property IOSTANDARD LVDS_25 [get_ports adc_outa_p_i[6]]
set_property IOSTANDARD LVDS_25 [get_ports adc_outa_p_i[5]]
set_property IOSTANDARD LVDS_25 [get_ports adc_outa_p_i[4]]
set_property IOSTANDARD LVDS_25 [get_ports adc_outa_p_i[3]]
set_property IOSTANDARD LVDS_25 [get_ports adc_outa_p_i[2]]
set_property IOSTANDARD LVDS_25 [get_ports adc_outa_p_i[1]]
set_property IOSTANDARD LVDS_25 [get_ports adc_outa_p_i[0]]
set_property IOSTANDARD LVDS_25 [get_ports adc_outa_n_i[7]]
set_property IOSTANDARD LVDS_25 [get_ports adc_outa_n_i[6]]
set_property IOSTANDARD LVDS_25 [get_ports adc_outa_n_i[5]]
set_property IOSTANDARD LVDS_25 [get_ports adc_outa_n_i[4]]
set_property IOSTANDARD LVDS_25 [get_ports adc_outa_n_i[3]]
set_property IOSTANDARD LVDS_25 [get_ports adc_outa_n_i[2]]
set_property IOSTANDARD LVDS_25 [get_ports adc_outa_n_i[1]]
set_property IOSTANDARD LVDS_25 [get_ports adc_outa_n_i[0]]
set_property IOSTANDARD LVDS_25 [get_ports adc_lclk_p_i]
set_property IOSTANDARD LVDS_25 [get_ports adc_lclk_n_i]
set_property IOSTANDARD LVDS_25 [get_ports adc_adclk_p_i]
set_property IOSTANDARD LVDS_25 [get_ports adc_adclk_n_i]

# Enable termination
set_property DIFF_TERM TRUE [get_ports adc_outb_p_i[7]]
set_property DIFF_TERM TRUE [get_ports adc_outb_p_i[6]]
set_property DIFF_TERM TRUE [get_ports adc_outb_p_i[5]]
set_property DIFF_TERM TRUE [get_ports adc_outb_p_i[4]]
set_property DIFF_TERM TRUE [get_ports adc_outb_p_i[3]]
set_property DIFF_TERM TRUE [get_ports adc_outb_p_i[2]]
set_property DIFF_TERM TRUE [get_ports adc_outb_p_i[1]]
set_property DIFF_TERM TRUE [get_ports adc_outb_p_i[0]]
set_property DIFF_TERM TRUE [get_ports adc_outb_n_i[7]]
set_property DIFF_TERM TRUE [get_ports adc_outb_n_i[6]]
set_property DIFF_TERM TRUE [get_ports adc_outb_n_i[5]]
set_property DIFF_TERM TRUE [get_ports adc_outb_n_i[4]]
set_property DIFF_TERM TRUE [get_ports adc_outb_n_i[3]]
set_property DIFF_TERM TRUE [get_ports adc_outb_n_i[2]]
set_property DIFF_TERM TRUE [get_ports adc_outb_n_i[1]]
set_property DIFF_TERM TRUE [get_ports adc_outb_n_i[0]]
set_property DIFF_TERM TRUE [get_ports adc_outa_p_i[7]]
set_property DIFF_TERM TRUE [get_ports adc_outa_p_i[6]]
set_property DIFF_TERM TRUE [get_ports adc_outa_p_i[5]]
set_property DIFF_TERM TRUE [get_ports adc_outa_p_i[4]]
set_property DIFF_TERM TRUE [get_ports adc_outa_p_i[3]]
set_property DIFF_TERM TRUE [get_ports adc_outa_p_i[2]]
set_property DIFF_TERM TRUE [get_ports adc_outa_p_i[1]]
set_property DIFF_TERM TRUE [get_ports adc_outa_p_i[0]]
set_property DIFF_TERM TRUE [get_ports adc_outa_n_i[7]]
set_property DIFF_TERM TRUE [get_ports adc_outa_n_i[6]]
set_property DIFF_TERM TRUE [get_ports adc_outa_n_i[5]]
set_property DIFF_TERM TRUE [get_ports adc_outa_n_i[4]]
set_property DIFF_TERM TRUE [get_ports adc_outa_n_i[3]]
set_property DIFF_TERM TRUE [get_ports adc_outa_n_i[2]]
set_property DIFF_TERM TRUE [get_ports adc_outa_n_i[1]]
set_property DIFF_TERM TRUE [get_ports adc_outa_n_i[0]]
set_property DIFF_TERM TRUE [get_ports adc_lclk_p_i]
set_property DIFF_TERM TRUE [get_ports adc_lclk_n_i]
set_property DIFF_TERM TRUE [get_ports adc_adclk_p_i]
set_property DIFF_TERM TRUE [get_ports adc_adclk_n_i]

# Clocks
create_clock -period 10.000 -name fpga_clk -waveform {0.000  5.000} [get_ports {fpga_clk_p_i}]
create_clock -period 3.333 -name adc_clk -waveform {0.000  1.666} [get_ports {adc_lclk_p_i}]

# set_max_delay -from [get_clocks inst_bufr_lclk_n_0] -to [get_clocks clk_100_out] -datapath_only 10.0
set_max_delay -from adc_clk -to fpga_clk -datapath_only 3.333
set_max_delay -from inst_bufr_lclk_n_0 -to clk_100_out -datapath_only 10.0

# set_clock_groups -asynchronous -group fpga_clk -group adc_clk
