`timescale 1ns / 1ps

import sys_top_sub_reg_Consts::*;

module diot_sys_tb;
    reg [31:0] read_data;
    reg resp;
    
    reg clk_n, clk_p;

    diot_sys_top uut(.fpga_pl_clkref_n_i(clk_n), .fpga_pl_clkref_p_i(clk_p),.board_sda_b(),.board_scl_b());

`define UUT uut.inst_zynq_us
`define BASE 32'hA0000000

    // Clock (100Mhz, so 10ns)
    initial forever begin
        clk_n = 1'b0;
        clk_p = 1'b1;
        # 5;
        clk_n = 1'b1;
        clk_p = 1'b0;
        # 5;
    end
    
    initial
    begin
    
        $display ("running the tb");
        
//        repeat(5) @(posedge clk_p);
          

        `UUT.zynq_ultra_ps_e_0.inst.por_srstb_reset(1'b1);
        #200;
	    $display ("reset 1");
        `UUT.zynq_ultra_ps_e_0.inst.por_srstb_reset(1'b0);
        `UUT.zynq_ultra_ps_e_0.inst.fpga_soft_reset(32'h1);
        #200 ;  // This delay depends on your clock frequency. It should be at least 16 clock cycles. 
	    $display ("reset 2");
        `UUT.zynq_ultra_ps_e_0.inst.por_srstb_reset(1'b1);
        `UUT.zynq_ultra_ps_e_0.inst.fpga_soft_reset(32'h0);
        #700 ;
        
	    $display ("Out of reset");
    			
        // Set length and address
        @(posedge clk_p);
        `UUT.zynq_ultra_ps_e_0.inst.write_data(`BASE | ADDR_SYS_TOP_SUB_REG_LENGTH, 4, 40, resp);
        `UUT.zynq_ultra_ps_e_0.inst.write_data(`BASE | ADDR_SYS_TOP_SUB_REG_CONFIGS_0_ADDRESS, 4, 32'h10000000, resp);
        `UUT.zynq_ultra_ps_e_0.inst.write_data(`BASE | ADDR_SYS_TOP_SUB_REG_CONFIG, 4, SYS_TOP_SUB_REG_CONFIG_PATTERNS, resp);
        
        $display ("Trigger 1");
        `UUT.zynq_ultra_ps_e_0.inst.write_data(`BASE | ADDR_SYS_TOP_SUB_REG_CONTROL, 4, SYS_TOP_SUB_REG_CONTROL_SW_TRIG, resp);
        
        #1000;
        
        $display ("Trigger 2");
        `UUT.zynq_ultra_ps_e_0.inst.write_data(`BASE | ADDR_SYS_TOP_SUB_REG_CONTROL, 4, SYS_TOP_SUB_REG_CONTROL_SW_TRIG, resp);
        # 50;
 
        forever begin
            `UUT.zynq_ultra_ps_e_0.inst.read_data(`BASE | ADDR_SYS_TOP_SUB_REG_STATUS, 4,read_data,resp);
            $display ("%t, status 32'h%x",$time, read_data);
            if (!(read_data & SYS_TOP_SUB_REG_STATUS_TRANSFER))
              break;
            # 1000;
        end
        # 50;
        $stop;
    end	
endmodule

